define(["require", "exports", "react"], function (require, exports, react_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var useInterval = function (callback, delay) {
        var savedCallback = react_1.useRef(callback);
        // Remember the latest callback.
        react_1.useEffect(function () {
            savedCallback.current = callback;
        });
        // Set up the interval.
        react_1.useEffect(function () {
            function tick() {
                savedCallback.current();
            }
            if (delay !== null) {
                var id_1 = setInterval(tick, delay);
                return function () { return clearInterval(id_1); };
            }
        }, [delay]);
    };
    exports.default = useInterval;
});
//# sourceMappingURL=../../src/dist/ux/useInterval.js.map