var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
define(["require", "exports", "react", "json2mq"], function (require, exports, react_1, json2mq_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    json2mq_1 = __importDefault(json2mq_1);
    function useMedia(query, defaultMatches) {
        if (defaultMatches === void 0) { defaultMatches = true; }
        var _a = react_1.useState(defaultMatches), matches = _a[0], setMatches = _a[1];
        react_1.useEffect(function () {
            var mediaQueryList = window.matchMedia(typeof query === 'string' ? query : json2mq_1.default(query));
            var active = true;
            var listener = function () {
                if (!active) {
                    return;
                }
                if (mediaQueryList.matches) {
                    setMatches(true);
                }
                else {
                    setMatches(false);
                }
            };
            mediaQueryList.addListener(listener);
            setMatches(mediaQueryList.matches);
            return function () {
                active = false;
                mediaQueryList.removeListener(listener);
            };
        }, [query]);
        return matches;
    }
    exports.useMedia = useMedia;
});
//# sourceMappingURL=../../src/dist/ux/useMedia.js.map